# generated from rosidl_generator_py/resource/_msg.py.em
# generated code does not contain a copyright notice

from copy import copy
import logging
import traceback


class Metaclass(type):
    """Metaclass of message 'GetJointProperties_Response'."""

    _CREATE_ROS_MESSAGE = None
    _CONVERT_FROM_PY = None
    _CONVERT_TO_PY = None
    _DESTROY_ROS_MESSAGE = None
    _TYPE_SUPPORT = None

    __constants = {
        'REVOLUTE': 0,
        'CONTINUOUS': 1,
        'PRISMATIC': 2,
        'FIXED': 3,
        'BALL': 4,
        'UNIVERSAL': 5,
    }

    @classmethod
    def __import_type_support__(cls):
        try:
            from rosidl_generator_py import import_type_support
            module = import_type_support('gazebo_msgs')
        except ImportError:
            logger = logging.getLogger('rosidl_generator_py.GetJointProperties_Response')
            logger.debug(
                'Failed to import needed modules for type support:\n' + traceback.format_exc())
        else:
            cls._CREATE_ROS_MESSAGE = module.create_ros_message_msg__srv_get_joint_properties__response
            cls._CONVERT_FROM_PY = module.convert_from_py_msg__srv_get_joint_properties__response
            cls._CONVERT_TO_PY = module.convert_to_py_msg__srv_get_joint_properties__response
            cls._TYPE_SUPPORT = module.type_support_msg__srv_get_joint_properties__response
            cls._DESTROY_ROS_MESSAGE = module.destroy_ros_message_msg__srv_get_joint_properties__response

    @classmethod
    def __prepare__(cls, name, bases, **kwargs):
        # list constant names here so that they appear in the help text of
        # the message class under "Data and other attributes defined here:"
        # as well as populate each message instance
        return {
            'REVOLUTE': cls.__constants['REVOLUTE'],
            'CONTINUOUS': cls.__constants['CONTINUOUS'],
            'PRISMATIC': cls.__constants['PRISMATIC'],
            'FIXED': cls.__constants['FIXED'],
            'BALL': cls.__constants['BALL'],
            'UNIVERSAL': cls.__constants['UNIVERSAL'],
        }

    @property
    def REVOLUTE(self):
        """Message constant 'REVOLUTE'."""
        return Metaclass.__constants['REVOLUTE']

    @property
    def CONTINUOUS(self):
        """Message constant 'CONTINUOUS'."""
        return Metaclass.__constants['CONTINUOUS']

    @property
    def PRISMATIC(self):
        """Message constant 'PRISMATIC'."""
        return Metaclass.__constants['PRISMATIC']

    @property
    def FIXED(self):
        """Message constant 'FIXED'."""
        return Metaclass.__constants['FIXED']

    @property
    def BALL(self):
        """Message constant 'BALL'."""
        return Metaclass.__constants['BALL']

    @property
    def UNIVERSAL(self):
        """Message constant 'UNIVERSAL'."""
        return Metaclass.__constants['UNIVERSAL']


class GetJointProperties_Response(metaclass=Metaclass):
    """
    Message class 'GetJointProperties_Response'.

    Constants:
      REVOLUTE
      CONTINUOUS
      PRISMATIC
      FIXED
      BALL
      UNIVERSAL
    """

    __slots__ = [
        '_type',
        '_damping',
        '_position',
        '_rate',
        '_success',
        '_status_message',
    ]

    _fields_and_field_types = {
        'type': 'uint8',
        'damping': 'float64[]',
        'position': 'float64[]',
        'rate': 'float64[]',
        'success': 'bool',
        'status_message': 'string',
    }

    def __init__(self, **kwargs):
        assert all('_' + key in self.__slots__ for key in kwargs.keys()), \
            'Invalid arguments passed to constructor: %s' % \
            ', '.join(sorted(k for k in kwargs.keys() if '_' + k not in self.__slots__))
        self.type = kwargs.get('type', int())
        self.damping = kwargs.get('damping', [])
        self.position = kwargs.get('position', [])
        self.rate = kwargs.get('rate', [])
        self.success = kwargs.get('success', bool())
        self.status_message = kwargs.get('status_message', str())

    def __repr__(self):
        typename = self.__class__.__module__.split('.')
        typename.pop()
        typename.append(self.__class__.__name__)
        args = [s[1:] + '=' + repr(getattr(self, s, None)) for s in self.__slots__]
        return '%s(%s)' % ('.'.join(typename), ', '.join(args))

    def __eq__(self, other):
        if not isinstance(other, self.__class__):
            return False
        if self.type != other.type:
            return False
        if self.damping != other.damping:
            return False
        if self.position != other.position:
            return False
        if self.rate != other.rate:
            return False
        if self.success != other.success:
            return False
        if self.status_message != other.status_message:
            return False
        return True

    @classmethod
    def get_fields_and_field_types(cls):
        return copy(cls._fields_and_field_types)

    @property  # noqa: A003
    def type(self):
        """Message field 'type'."""
        return self._type

    @type.setter  # noqa: A003
    def type(self, value):
        if __debug__:
            assert \
                isinstance(value, int), \
                "The 'type' field must of type 'int'"
            assert value >= 0 and value < 256, \
                "The 'type' field must be an unsigned integer in [0, 255]"
        self._type = value

    @property
    def damping(self):
        """Message field 'damping'."""
        return self._damping

    @damping.setter
    def damping(self, value):
        if __debug__:
            from collections.abc import Sequence
            from collections.abc import Set
            from collections import UserList
            from collections import UserString
            assert \
                ((isinstance(value, Sequence) or
                  isinstance(value, Set) or
                  isinstance(value, UserList)) and
                 not isinstance(value, str) and
                 not isinstance(value, UserString) and
                 all(isinstance(v, float) for v in value) and
                 True), \
                "The 'damping' field must be a set or sequence and each value of type 'float'"
        self._damping = value

    @property
    def position(self):
        """Message field 'position'."""
        return self._position

    @position.setter
    def position(self, value):
        if __debug__:
            from collections.abc import Sequence
            from collections.abc import Set
            from collections import UserList
            from collections import UserString
            assert \
                ((isinstance(value, Sequence) or
                  isinstance(value, Set) or
                  isinstance(value, UserList)) and
                 not isinstance(value, str) and
                 not isinstance(value, UserString) and
                 all(isinstance(v, float) for v in value) and
                 True), \
                "The 'position' field must be a set or sequence and each value of type 'float'"
        self._position = value

    @property
    def rate(self):
        """Message field 'rate'."""
        return self._rate

    @rate.setter
    def rate(self, value):
        if __debug__:
            from collections.abc import Sequence
            from collections.abc import Set
            from collections import UserList
            from collections import UserString
            assert \
                ((isinstance(value, Sequence) or
                  isinstance(value, Set) or
                  isinstance(value, UserList)) and
                 not isinstance(value, str) and
                 not isinstance(value, UserString) and
                 all(isinstance(v, float) for v in value) and
                 True), \
                "The 'rate' field must be a set or sequence and each value of type 'float'"
        self._rate = value

    @property
    def success(self):
        """Message field 'success'."""
        return self._success

    @success.setter
    def success(self, value):
        if __debug__:
            assert \
                isinstance(value, bool), \
                "The 'success' field must of type 'bool'"
        self._success = value

    @property
    def status_message(self):
        """Message field 'status_message'."""
        return self._status_message

    @status_message.setter
    def status_message(self, value):
        if __debug__:
            assert \
                isinstance(value, str), \
                "The 'status_message' field must of type 'str'"
        self._status_message = value
